<template>
  <div class="previewer-class-schedule fit">
    <q-list
      class="tool mr-20px"
      bordered
      separato
    >
      <q-item>
        <q-btn
          round
          flat
          icon="download"
          @click="submitDownloadXcel"
        >
          <q-tooltip>下載 Excel 檔</q-tooltip>
        </q-btn>
      </q-item>
    </q-list>
    <transition
      name="opacity"
      mode="out-in"
    >
      <div
        v-if="!props.classSchedule"
        class="class-schedule h-full"
      >
        <div class="fit flex flex-center bg-grey-2">
          <div class="text-24px">
            請選擇班表
          </div>
        </div>
      </div>
      <div
        v-else
        :key="header"
        class="class-schedule"
      >
        <div class="header text-12px p-10px">
          {{ header }}
        </div>
        <table>
          <tbody>
            <tr
              v-for="row in rows"
              :key="row.toString()"
            >
              <td
                v-for="item in row"
                :key="item.toString()"
                class="item text-center"
                :class="item.classes"
              >
                {{ item.value }}
              </td>
            </tr>
          </tbody>
        </table>
      </div>
    </transition>
  </div>
</template>

<script lang='ts' setup>
import dayjs from 'dayjs';
import { range } from 'lodash-es';
import { computed, toRefs } from 'vue';
import { Border, Workbook } from 'exceljs';
import { saveAs } from 'file-saver';
import { ClassSchedule } from '../types/main.type';

import { useQuasar } from 'quasar';
import { useStatisticalData } from '../composables/use-statistical-data';
import { useMainStore } from '../store/main.store';

const DayOfWeekArray = ['日', '一', '二', '三', '四', '五', '六'];

interface Props {
  classSchedule?: ClassSchedule;
}

const props = withDefaults(defineProps<Props>(), {
  classSchedule: undefined,
});

interface Cell {
  classes: string;
  value: string;
}

const store = useMainStore();
const $q = useQuasar();

const staff = computed(() => store.staff);

const header = computed(() => {
  if (!props.classSchedule) {
    return ''
  }

  const { name, month, itineraries } = toRefs(props.classSchedule);

  const { unscheduledDays } = useStatisticalData({
    rosterMonth: month,
    dayItineraries: itineraries,
  });

  return [
    `班表名稱：${name.value}`,
    `年月份：${month.value}`,
    `休假天數：${unscheduledDays.value}`,
  ].join('　　');
});

/** 無法排班日子 */
const unableScheduleDays = computed(() => {
  if (!props.classSchedule) {
    return [];
  }

  const { itineraries } = toRefs(props.classSchedule);

  const days = itineraries.value
    .filter((itinerary) => {
      const thisDay = itinerary.vacancies.some(({ executor }) => !executor);
      return thisDay;
    })
    .map(({ date }) => {
      return `${dayjs(date).date()}`;
    });

  return days;
});

const rows = computed(() => {
  const rows: Cell[][] = [];

  const classSchedule = props.classSchedule;

  if (!classSchedule) {
    return rows;
  }

  const daysInMonth = dayjs(classSchedule.month).daysInMonth();
  const daysRange = range(1, daysInMonth + 1).map((i) => `${i}`);

  // 第一列為日數值
  {
    // 第一列保留姓名
    const row = ['', ...daysRange].map((item) => {
      const classes = unableScheduleDays.value.includes(item)
        ? 'bg-red text-white'
        : '';

      return {
        classes,
        value: item,
      };
    });
    rows.push(row);
  }

  // 第二列為星期
  {
    const dateObj = dayjs(`${classSchedule.month}/01`);

    // 第一列保留姓名
    const row: Cell[] = [
      {
        classes: '',
        value: '',
      },
    ];
    for (let i = 0; i < daysInMonth; i++) {
      const dayString = DayOfWeekArray[dateObj.add(i, 'day').day()];

      const classes = ['六', '日'].includes(dayString) ? 'bg-grey-4' : '';
      row.push({
        classes,
        value: dayString,
      });
    }

    rows.push(row);
  }

  // 列出所有人
  {
    staff.value.forEach((member) => {
      const row: Cell[] = [
        {
          classes: '',
          value: member.name,
        },
      ];

      daysRange.forEach((day) => {
        const targetDate = `${classSchedule.month}/${day.padStart(2, '0')}`;

        const targetItinerary = classSchedule.itineraries.find(
          ({ date }) => targetDate === date
        );
        if (!targetItinerary) {
          row.push({
            classes: '',
            value: '',
          });
          return;
        }

        const targetVacancy = targetItinerary.vacancies.find(({ executor }) => {
          return executor?.name === member.name;
        });
        if (!targetVacancy) {
          row.push({
            classes: '',
            value: '',
          });
          return;
        }

        const item = `${targetVacancy.job?.codename}${targetVacancy.jobType?.codename}`;
        row.push({
          classes: '',
          value: item,
        });
      });

      rows.push(row);
    });
  }

  return rows;
});

function submitDownloadXcel() {
  if (!props.classSchedule) {
    $q.notify({
      type: 'negative',
      message: '無班表資料，無法下載',
    });
    return;
  }

  if (unableScheduleDays.value.length !== 0) {
    $q.notify({
      type: 'warning',
      message: '有部分日期無法排班，確定仍要下載？',
      actions: [
        {
          label: '取消',
          color: 'white',
        },
        {
          label: '確認',
          color: 'white',
          class: 'bg-secondary',
          handler: () => {
            downloadXcel();
          },
        },
      ],
    });
    return;
  }

  downloadXcel();
}

function createWorkbook() {
  if (!props.classSchedule) {
    return;
  }

  const workbook = new Workbook();

  const sheetName = props.classSchedule.month.replaceAll('/', '-');
  const sheet = workbook.addWorksheet(sheetName);

  // 加入 header
  sheet.addRow([header.value]);

  // 加入 rows
  const rowsString = rows.value.map((row) => row.map(({ value }) => value));
  sheet.addRows(rowsString);

  // # 處理樣式

  // ## 合併 header
  const lastCell = sheet.columnCount;
  sheet.mergeCells(1, 1, 1, lastCell);

  // ## 全部加上邊框
  sheet.eachRow((row, number) => {
    const style: Partial<Border> = { style: 'thin' };

    row.eachCell({ includeEmpty: true }, (cell) => {
      cell.border = {
        top: style,
        left: style,
        bottom: style,
        right: style,
      };
    });
  });

  // ## header 加入粗底線
  sheet.getCell('A1').border = {
    bottom: {
      style: 'medium',
    },
  };

  // ## 縮小第一列以外寬度，並置中對其
  for (let i = 2; i <= sheet.columnCount; i++) {
    const col = sheet.getColumn(i);
    col.width = 4;
    col.alignment = {
      vertical: 'middle',
      horizontal: 'center',
    };
  }

  return workbook;
}

function downloadXcel() {
  if (!props.classSchedule) return;


  const workbook = createWorkbook();

  if (!workbook) return;


  const month = props.classSchedule.month.replaceAll('/', '');
  const timestamp = dayjs().format('YYYYMMDD');
  const fileNames = [month, '班表', timestamp];
  if (props.classSchedule.name) {
    fileNames.unshift(props.classSchedule.name);
  }

  // 下載
  workbook.xlsx
    .writeBuffer()
    .then((buffer) => {
      saveAs(
        new Blob([buffer], {
          type: 'application/vnd.openxmlformats-officedocument.spreadsheetml.sheet',
        }),
        fileNames.join('-')
      );
    })
    .catch((err) => {
      $q.notify({
        type: 'negative',
        message: `輸出 Excel 發生錯誤 : ${err}`,
      });
    });
}
</script>

<style scoped lang='sass'>

.previewer-class-schedule
  display: flex

.class-schedule
  width: 1000px

  .header
    border: 1px solid #000

  table
    width: 100%
    border-spacing: 0px
    border: 1px solid #000
    border-collapse: collapse
  thead
    width: 100%
    display: table

.item
  border: 1px solid #000
  flex: 1
</style>